Index: coreboot-v3/device/device.c
===================================================================
--- coreboot-v3.orig/device/device.c
+++ coreboot-v3/device/device.c
@@ -1016,6 +1016,7 @@ void dev_phase4(void)
 	 * highest addresses I can manage.
 	 */
 	mem->base = resource_max(&root->resource[1]);
+	mem->base = 0xfc000000;
 	mem->flags |= IORESOURCE_ASSIGNED;
 	mem->flags &= ~IORESOURCE_STORED;
 
Index: coreboot-v3/device/pci_device.c
===================================================================
--- coreboot-v3.orig/device/pci_device.c
+++ coreboot-v3/device/pci_device.c
@@ -725,9 +725,47 @@ void pci_dev_init(struct device *dev)
 
 	printk(BIOS_INFO, "Probing for option ROM\n");
 	rom = pci_rom_probe(dev);
+	printk(BIOS_INFO, "Probe returns %p\n",rom);
 	if (rom == NULL)
 		return;
 	ram = pci_rom_load(dev, rom);
+	printk(BIOS_INFO, "Load returns %p\n",ram);
+
+	/* This is for paranoia's sake */
+	pci_conf1_write_config32(PCI_BDF(0,0xa,0),0x28, 0x00000000);
+	pci_conf1_write_config32(PCI_BDF(0,0xa,0),0x2c, 0x00000000);
+	pci_conf1_write_config32(PCI_BDF(0,0xb,0),0x28, 0x00000000);
+	pci_conf1_write_config32(PCI_BDF(0,0xb,0),0x2c, 0x00000000);
+
+	pci_conf1_write_config32(PCI_BDF(0,0x18,0),0x6c, 0x00000270);
+
+	pci_conf1_write_config32(PCI_BDF(0,0x18,2),0x88, 0xdf004002);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,2),0x94, 0x34009078);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,2),0x98, 0xc0000030);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,2),0xa0, 0xdf0020e9);
+
+	pci_conf1_write_config32(PCI_BDF(0,0x18,3),0x58, 0x00161616);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,3),0x5c, 0x00030000);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,3),0x5c, 0x00070000);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,3),0x5c, 0x00030000);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,3),0x80, 0x00000000);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,3),0x84, 0x00000000);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,3),0x90, 0x00000002);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,3),0x94, 0x0000007c);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,3),0xd4, 0x0000a000);
+	pci_conf1_write_config32(PCI_BDF(0,0x18,3),0xd8, 0x00000000);
+
+	pci_conf1_write_config16(PCI_BDF(0,0x6,0),0x4, 0x0107);
+	pci_conf1_write_config16(PCI_BDF(1,0x0,0),0x4, 0x0002);
+	pci_conf1_write_config16(PCI_BDF(1,0x0,1),0x4, 0x0002);
+	pci_conf1_write_config16(PCI_BDF(1,0x4,0),0x4, 0x0003);
+	pci_conf1_write_config16(PCI_BDF(1,0x5,0),0x4, 0x0003);
+
+	pci_conf1_write_config16(PCI_BDF(0,0x7,3),0x42, 0x2000);
+	pci_conf1_write_config16(PCI_BDF(0,0x7,3),0x70, 0x0000);
+	pci_conf1_write_config16(PCI_BDF(0,0x7,3),0x72, 0x0000);
+	pci_conf1_write_config16(PCI_BDF(0,0x7,3),0x74, 0x0000);
+
 	if (ram == NULL)
 		return;
 	run_bios(dev, (unsigned long)ram);
